----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:37:54 11/04/2015 
-- Design Name: 
-- Module Name:    check_event - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity check_event is
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           en_stop : in  STD_LOGIC_VECTOR (7 downto 0);
           cmsCRC_err : in  STD_LOGIC_VECTOR (2 downto 0);
					 EventData_in : in array3X67;
					 EventData_we : in   std_logic_VECTOR(2 downto 0);
           inc_err : out  STD_LOGIC_VECTOR (7 downto 0);
           stop : out  STD_LOGIC);
end check_event;

architecture Behavioral of check_event is
signal EvtLengthCntr : array3X24 := (others => (others => '0'));
signal EvtLength_err : std_logic_vector(2 downto 0) := (others => '0');

begin
process(clk)
begin
	if(clk'event and clk = '1')then
		for i in 0 to 2 loop
			if(reset = '1')then
				EvtLengthCntr(i) <= x"000001";
			elsif(EventData_we(i) = '1')then
				if(EventData_in(i)(65) = '1')then
					EvtLengthCntr(i) <= x"000001";
				else
					EvtLengthCntr(i) <= EvtLengthCntr(i) + 1;
				end if;
			end if;
			if(EventData_we(i) = '1' and EventData_in(i)(65) = '1' and EventData_in(i)(55 downto 32) /= EvtLengthCntr(i))then
				EvtLength_err(i) <= '1';
			else
				EvtLength_err(i) <= '0';
			end if;
		end loop;
	end if;
end process;

end Behavioral;

