----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:14:08 05/19/2015 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity MPA_top is
    Port ( 
-- Gigabit Ethernet pins
					 clk125 : in  STD_LOGIC;
           beam_clk : in  STD_LOGIC;
           beam_data : in  STD_LOGIC;
           led : out  STD_LOGIC_VECTOR(1 to 2);
-- MAP light pins
					 hitOR_p : in  STD_LOGIC;
           hitOR_n : in  STD_LOGIC;
					 shutter_p : out  STD_LOGIC;
           shutter_n : out  STD_LOGIC;
					 calstrobe_p : out  STD_LOGIC;
           calstrobe_n : out  STD_LOGIC;
					 conf_en_p : out  STD_LOGIC;
           conf_en_n : out  STD_LOGIC;
					 conf_clk_p : out  STD_LOGIC;
           conf_clk_n : out  STD_LOGIC;
					 conf_din_p : in  STD_LOGIC;
           conf_din_n : in  STD_LOGIC;
					 conf_dout_p : out  STD_LOGIC;
           conf_dout_n : out  STD_LOGIC;
					 read_clk_p : out  STD_LOGIC;
           read_clk_n : out  STD_LOGIC;
					 read_din_p : in  STD_LOGIC;
           read_din_n : in  STD_LOGIC;
					 read_dout_p : out  STD_LOGIC;
           read_dout_n : out  STD_LOGIC;
           mem_p : in  STD_LOGIC_VECTOR(5 downto 0);
           mem_n : in  STD_LOGIC_VECTOR(5 downto 0);
					 enutil_p : out  STD_LOGIC;
           enutil_n : out  STD_LOGIC;
					 util_clk_p : out  STD_LOGIC;
           util_clk_n : out  STD_LOGIC;
					 util_din_p : in  STD_LOGIC;
           util_din_n : in  STD_LOGIC;
					 util_dout_p : out  STD_LOGIC;
           util_dout_n : out  STD_LOGIC;
					 clk160_p : out  STD_LOGIC;
           clk160_n : out  STD_LOGIC;
           strip_strobe_in_p : in  STD_LOGIC_VECTOR(5 downto 0);
           strip_strobe_in_n : in  STD_LOGIC_VECTOR(5 downto 0);
           strip_data_in_p : in  STD_LOGIC_VECTOR(23 downto 0);
           strip_data_in_n : in  STD_LOGIC_VECTOR(23 downto 0);
           strip_strobe_out_p : out  STD_LOGIC_VECTOR(5 downto 0);
           strip_strobe_out_n : out  STD_LOGIC_VECTOR(5 downto 0);
           strip_data_out_p : out  STD_LOGIC_VECTOR(23 downto 0);
           strip_data_out_n : out  STD_LOGIC_VECTOR(23 downto 0);
					 ipb_clk : in std_logic;
					 ipb_write : in std_logic;
					 ipb_strobe : in std_logic;
           ipb_addr : in  STD_LOGIC_VECTOR(15 downto 0);
           ipb_wdata : in  STD_LOGIC_VECTOR(31 downto 0);
           ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out std_logic
					 );
end MPA_top;

architecture Behavioral of MPA_top is
COMPONENT clocks
	PORT(
		clk125 : IN std_logic;
		beam_clk : IN std_logic;
		test_beam : IN std_logic;
		PS_reg : IN std_logic_vector(8 downto 0);          
		beam_clk_out : OUT std_logic;
		clk160from125 : OUT std_logic;
		clk400 : OUT std_logic;
		mpaclk_en : IN std_logic;
		clk320 : OUT std_logic;
		clk160_PS : OUT std_logic;
		PS_ready : OUT std_logic;
		clk160_p : OUT std_logic;
		clk160_n : OUT std_logic
		);
END COMPONENT;
COMPONENT strip_in
	PORT(
		clk : IN std_logic;
		sysclk : IN std_logic;
		reset : IN std_logic;
		strip_strobe_in_p : IN std_logic_vector(5 downto 0);
		strip_strobe_in_n : IN std_logic_vector(5 downto 0);
		strip_data_in_p : IN std_logic_vector(23 downto 0);
		strip_data_in_n : IN std_logic_vector(23 downto 0);
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT strip_out
	PORT(
		clk : IN std_logic;
		sysclk : IN std_logic;
		reset : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		strip_strobe_out_p : OUT std_logic_vector(5 downto 0);
		strip_strobe_out_n : OUT std_logic_vector(5 downto 0);
		strip_data_out_p : OUT std_logic_vector(23 downto 0);
		strip_data_out_n : OUT std_logic_vector(23 downto 0);
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT SPIconf
	PORT(
		reset : IN std_logic;
		sysclk : IN std_logic;
		conf_din_p : IN std_logic;
		conf_din_n : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		conf_en_p : OUT std_logic;
		conf_en_n : OUT std_logic;
		conf_clk_p : OUT std_logic;
		conf_clk_n : OUT std_logic;
		conf_dout_p : OUT std_logic;
		conf_dout_n : OUT std_logic;
		conf_done : OUT std_logic;
		nMPA : out std_logic_vector(2 downto 0);
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT SPIutil
	PORT(
		reset : IN std_logic;
		start : IN std_logic;
		read_only : IN std_logic;
		SR_data : IN std_logic_vector(15 downto 0);
		util_din_p : IN std_logic;
		util_din_n : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		done : OUT std_logic;
		mpa_empty : OUT std_logic_vector(5 downto 0);
		mpa_hitOR : OUT std_logic_vector(5 downto 0);
		enutil_p : OUT std_logic;
		enutil_n : OUT std_logic;
		util_clk_p : OUT std_logic;
		util_clk_n : OUT std_logic;
		util_dout_p : OUT std_logic;
		util_dout_n : OUT std_logic;
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT MPAread
	PORT(
		reset : IN std_logic;
		sysclk : IN std_logic;
		set_read_clk : IN std_logic;
		read_start : IN std_logic;
		read_all : IN std_logic;
		read_addr : IN std_logic_vector(1 downto 0);
		read_din_p : IN std_logic;
		read_din_n : IN std_logic;
		mem_p : IN std_logic_vector(5 downto 0);
		mem_n : IN std_logic_vector(5 downto 0);
		nMPA : IN std_logic_vector(2 downto 0);
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		read_clk_p : OUT std_logic;
		read_clk_n : OUT std_logic;
		read_dout_p : OUT std_logic;
		read_dout_n : OUT std_logic;
		read_done : OUT std_logic;
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT acquisition
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		beam_start : IN std_logic;
		beam_halt : IN std_logic;
		test_beam : IN std_logic;
		start : IN std_logic;
		hitOR_p : in  STD_LOGIC;
    hitOR_n : in  STD_LOGIC;
		IsCalib : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		setCLKOR : OUT std_logic;
		done : OUT std_logic;
		shutter_p : OUT std_logic;
		shutter_n : OUT std_logic;
		calstrobe_p : OUT std_logic;
		calstrobe_n : OUT std_logic;
		ipb_rdata : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
COMPONENT trigpattern
  GENERIC (
    PATTERN : STD_LOGIC_VECTOR := "00000";
    CLOCK_EDGE : STRING := "FALLING";
    WIDTH : INTEGER := 1
  );
	PORT(
		CLK : IN std_logic;
		D : IN std_logic;          
		TRIGGER : OUT std_logic
		);
END COMPONENT;
function CLOCK_EDGE(beam_clk_pol : std_logic) return string is
	begin
		if(beam_clk_pol = '0')then
			return "FALLING";
		else
			return "RISING";
		end if;
	end function;
constant beam_clk_pol : std_logic := '0';
constant beam_data_pol : std_logic := '0';
constant version : std_logic_vector(15 downto 0) := x"000a";
constant zero : std_logic_vector(31 downto 0) := (others =>'0');
signal test_beam : std_logic := '0';
signal trig_clk : std_logic := '0';
signal sysclk : std_logic := '0';
signal reset : std_logic := '0';
signal clk320 : std_logic := '0';
signal clk400 : std_logic := '0';
signal mpaclk_en : std_logic := '0';
signal clk160_PS : std_logic := '0';
signal clk160from125 : std_logic := '0';
signal PS_ready : std_logic := '0';
signal PS_reg : std_logic_vector(8 downto 0) := (others =>'0');
signal sysclk_lock_n : std_logic := '0';
signal strip_in_data : std_logic_vector(31 downto 0) := (others =>'0');
signal strip_out_data : std_logic_vector(31 downto 0) := (others =>'0');
signal conf_data : std_logic_vector(31 downto 0) := (others =>'0');
signal conf_done : std_logic := '0';
signal IsCalib : std_logic := '0';
signal set_read_clk : std_logic := '0';
signal read_start : std_logic := '0';
signal read_all : std_logic := '0';
signal busy : std_logic := '0';
signal repeat : std_logic := '0';
signal restart : std_logic := '0';
signal restart_sync : std_logic_vector(3 downto 0) := (others =>'0');
signal read_done : std_logic := '0';
signal read_addr : std_logic_vector(1 downto 0) := (others =>'0');
signal buffer_avl : std_logic_vector(2 downto 0) := (others =>'0');
signal buffer_read : std_logic_vector(1 downto 0) := (others =>'0');
signal nMPA : std_logic_vector(2 downto 0) := (others =>'0');
signal read_data : std_logic_vector(31 downto 0) := (others =>'0');
signal util_start : std_logic := '0';
signal util_read_only : std_logic := '0';
signal util_done : std_logic := '0';
signal util_SR_data : std_logic_vector(15 downto 0) := (others =>'0');
signal util_data : std_logic_vector(31 downto 0) := (others =>'0');
signal mpa_empty : std_logic_vector(5 downto 0) := (others =>'0');
signal mpa_hitOR : std_logic_vector(5 downto 0) := (others =>'0');
signal acq_start : std_logic := '0';
signal acq_done : std_logic := '0';
signal acq_data : std_logic_vector(31 downto 0) := (others =>'0');
signal reset_cntr : std_logic_vector(23 downto 0) := (others =>'0');
signal beam_trig : std_logic := '0';
signal beam_trigp : std_logic := '0';
signal en_beam_trig : std_logic := '0';
signal trig_busy : std_logic := '0';
signal beam_start : std_logic := '0';
signal beam_halt : std_logic := '0';
signal beam_datap : std_logic := '0';
signal beam_start_sync : std_logic_vector(4 downto 0) := (others =>'0');
signal beam_halt_sync : std_logic_vector(4 downto 0) := (others =>'0');
signal beam_trig_sync : std_logic_vector(4 downto 0) := (others =>'0');
signal rst_beam_cntrA : std_logic := '1';
signal beam_cntrA : std_logic_vector(31 downto 0) := (others =>'0');
signal trig_cntr : std_logic_vector(19 downto 0) := (others =>'0');
signal trig_cntrA : std_logic_vector(9 downto 0) := (others =>'0');
signal trig_bufA : std_logic_vector(31 downto 0) := (others =>'0');
signal rst_beam_cntrB : std_logic := '1';
signal beam_cntrB : std_logic_vector(31 downto 0) := (others =>'0');
signal trig_bufB_wren : std_logic := '0';
signal trig_cntrB : std_logic_vector(9 downto 0) := (others =>'0');
signal trig_bufB : std_logic_vector(31 downto 0) := (others =>'0');
signal halt_time : std_logic_vector(31 downto 0) := (others =>'0');
begin
LED(1) <= 'Z';
LED(2) <= 'Z';
i_clk40_buf: bufg port map(i => clk125, o => sysclk);
i_clocks: clocks PORT MAP(
		clk125 => sysclk,
		beam_clk => beam_clk,
		test_beam => test_beam,
		beam_clk_out => trig_clk,
		clk160from125 => clk160from125,
		clk400 => clk400,
		clk320 => clk320,
		PS_reg => PS_reg,
		mpaclk_en => mpaclk_en,
		clk160_PS => clk160_PS,
		PS_ready => PS_ready,
		clk160_p => clk160_p,
		clk160_n => clk160_n
	);
i_strip_in: strip_in PORT MAP(
		clk => clk400,
		sysclk => sysclk,
		reset => reset,
		strip_strobe_in_p => strip_strobe_in_p,
		strip_strobe_in_n => strip_strobe_in_n,
		strip_data_in_p => strip_data_in_p,
		strip_data_in_n => strip_data_in_n,
		ipb_clk => ipb_clk,
		ipb_write => ipb_write,
		ipb_strobe => ipb_strobe,
		ipb_addr => ipb_addr,
		ipb_wdata => ipb_wdata,
		ipb_rdata => strip_in_data
	);
i_strip_out: strip_out PORT MAP(
		clk => clk160_PS,
		sysclk => sysclk,
		reset => reset,
		strip_strobe_out_p => strip_strobe_out_p,
		strip_strobe_out_n => strip_strobe_out_n,
		strip_data_out_p => strip_data_out_p,
		strip_data_out_n => strip_data_out_n,
		ipb_clk => ipb_clk,
		ipb_write => ipb_write,
		ipb_strobe => ipb_strobe,
		ipb_addr => ipb_addr,
		ipb_wdata => ipb_wdata,
		ipb_rdata => strip_out_data
	);
i_SPIconf: SPIconf PORT MAP(
		reset => reset,
		sysclk => sysclk,
		conf_en_p => conf_en_p,
		conf_en_n => conf_en_n,
		conf_clk_p => conf_clk_p,
		conf_clk_n => conf_clk_n,
		conf_din_p => conf_din_p,
		conf_din_n => conf_din_n,
		conf_dout_p => conf_dout_p,
		conf_dout_n => conf_dout_n,
		conf_done => conf_done,
		nMPA => nMPA,
		ipb_clk => ipb_clk,
		ipb_write => ipb_write,
		ipb_strobe => ipb_strobe,
		ipb_addr => ipb_addr,
		ipb_wdata => ipb_wdata,
		ipb_rdata => conf_data
	);
i_SPIutil: SPIutil PORT MAP(
		reset => reset,
		start => util_start,
		read_only => util_read_only,
		done => util_done,
		SR_data => util_SR_data,
		mpa_empty => mpa_empty,
		mpa_hitOR => mpa_hitOR,
		enutil_p => enutil_p,
		enutil_n => enutil_n,
		util_clk_p => util_clk_p,
		util_clk_n => util_clk_n,
		util_din_p => util_din_p,
		util_din_n => util_din_n,
		util_dout_p => util_dout_p,
		util_dout_n => util_dout_n,
		ipb_clk => ipb_clk,
		ipb_write => ipb_write,
		ipb_strobe => ipb_strobe,
		ipb_addr => ipb_addr,
		ipb_wdata => ipb_wdata,
		ipb_rdata => util_data
	);
i_MPAread: MPAread PORT MAP(
		reset => reset,
		sysclk => sysclk,
		set_read_clk => set_read_clk,
		read_start => read_start,
		read_all => read_all,
		read_addr => read_addr,
		read_clk_p => read_clk_p,
		read_clk_n => read_clk_n,
		read_din_p => read_din_p,
		read_din_n => read_din_n,
		read_dout_p => read_dout_p,
		read_dout_n => read_dout_n,
		read_done => read_done,
		mem_p => mem_p,
		mem_n => mem_n,
		nMPA => nMPA,
		ipb_clk => ipb_clk,
		ipb_write => ipb_write,
		ipb_strobe => ipb_strobe,
		ipb_addr => ipb_addr,
		ipb_wdata => ipb_wdata,
		ipb_rdata => read_data
	);
i_acquisition: acquisition PORT MAP(
		clk => clk320,
		reset => reset,
		beam_start => beam_trig,
		beam_halt => beam_halt,
		test_beam => test_beam,
		start => acq_start,
		hitOR_p => hitOR_p,
		hitOR_n => hitOR_n,
		IsCalib => IsCalib,
		setCLKOR => set_read_clk,
		done => acq_done,
		shutter_p => shutter_p,
		shutter_n => shutter_n,
		calstrobe_p => calstrobe_p,
		calstrobe_n => calstrobe_n,
		ipb_clk => ipb_clk,
		ipb_write => ipb_write,
		ipb_strobe => ipb_strobe,
		ipb_addr => ipb_addr,
		ipb_wdata => ipb_wdata,
		ipb_rdata => acq_data
	);
beam_datap <= beam_data_pol xor beam_data;
i_trigpattern: trigpattern generic map(pattern => "01010", CLOCK_EDGE => CLOCK_EDGE(beam_clk_pol)) PORT MAP(
		CLK => beam_clk,
		D => beam_datap,
		TRIGGER => beam_trigp
	);
i_startpattern: trigpattern generic map(pattern => "01101", CLOCK_EDGE => CLOCK_EDGE(beam_clk_pol), width => 4) PORT MAP(
		CLK => beam_clk,
		D => beam_datap,
		TRIGGER => beam_start
	);
i_haltpattern: trigpattern generic map(pattern => "00111", CLOCK_EDGE => CLOCK_EDGE(beam_clk_pol), width => 2) PORT MAP(
		CLK => beam_clk,
		D => beam_datap,
		TRIGGER => beam_halt
	);
process(beam_clk,restart)
begin
	if(restart = '1')then
		restart_sync <= (others => '1');
	elsif(beam_clk'event and beam_clk = '1')then
		restart_sync <= restart_sync(2 downto 0) & '0';
	end if;
end process;
process(beam_clk,reset)
begin
	if(reset = '1')then
		rst_beam_cntrA <= '1';
		trig_cntr <= (others => '0');
		trig_cntrA <= (others => '0');
		beam_cntrA <= (others => '0');
		beam_trig <= '0';
		en_beam_trig <= '0';
	elsif(beam_clk'event and beam_clk = '1')then
		if(beam_start = '1')then
			rst_beam_cntrA <= '0';
		elsif(beam_halt = '1')then
			rst_beam_cntrA <= '1';
		end if;
		if(beam_start = '1')then
			trig_cntr <= (others => '0');
			trig_cntrA <= (others => '0');
--		elsif(beam_trig = '1' and and_reduce(trig_cntrA) = '0')then
		elsif(beam_trig = '1')then
			trig_cntr <= trig_cntr + 1;
			trig_cntrA(1 downto 0) <= trig_cntrA(1 downto 0) + 1;
		end if;
		if(rst_beam_cntrA = '1')then
			beam_cntrA <= (others => '0');
		else
			beam_cntrA <= beam_cntrA + 1;
		end if;
		beam_trig <= beam_trigp and en_beam_trig;
		if(test_beam = '0' or beam_halt = '1' or beam_trig = '1')then
			en_beam_trig <= '0';
		elsif(beam_start = '1' or restart_sync(3 downto 2) = "10")then
			en_beam_trig <= '1';
		end if;
	end if;
end process;
process(beam_clk)
begin
	if(beam_clk'event and beam_clk = '1')then
		if(beam_halt = '1')then
			halt_time <= beam_cntrA;
		end if;
	end if;
end process;
i_trig_bufA : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "VIRTEX6", -- Target device: "VIRTEX5", "VIRTEX6", "SPARTAN6" 
      WRITE_WIDTH => 32,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32)     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
    port map (
      DO => trig_bufA,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => beam_cntrA,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => ipb_addr(9 downto 0), -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '0',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"f",         -- Input write enable, width defined by write port depth
      WRADDR => trig_cntrA, -- Input write address, width defined by write port depth
      WRCLK => beam_clk,   -- 1-bit input write clock
      WREN => beam_trig      -- 1-bit input write port enable
   );
process(clk160from125,reset)
begin
	if(reset = '1')then
		beam_start_sync <= (others => '0');
		beam_halt_sync <= (others => '0');
		beam_trig_sync <= (others => '0');
	elsif(clk160from125'event and clk160from125 = '1')then
		beam_start_sync(3 downto 0) <= beam_start_sync(2 downto 0) & beam_start;
		beam_start_sync(4) <= not beam_start_sync(3) and beam_start_sync(2);
		beam_halt_sync(3 downto 0) <= beam_halt_sync(2 downto 0) & beam_halt;
		beam_halt_sync(4) <= not beam_halt_sync(3) and beam_halt_sync(2);
		beam_trig_sync(3 downto 0) <= beam_trig_sync(2 downto 0) & beam_trig;
		beam_trig_sync(4) <= not beam_trig_sync(3) and beam_trig_sync(2);
	end if;
end process;
process(clk160from125,reset)
begin
	if(reset = '1')then
		rst_beam_cntrB <= '1';
		trig_cntrB <= (others => '0');
		beam_cntrB <= (others => '0');
	elsif(clk160from125'event and clk160from125 = '1')then
		if(beam_start_sync(4) = '1')then
			rst_beam_cntrB <= '0';
		elsif(beam_halt_sync(4) = '1')then
			rst_beam_cntrB <= '1';
		end if;
		if(beam_start_sync(4) = '1')then
			trig_cntrB <= (others => '0');
--		elsif(beam_trig_sync(4) = '1' and and_reduce(trig_cntrB) = '0')then
		elsif(beam_trig_sync(4) = '1')then
			trig_cntrB(1 downto 0) <= trig_cntrB(1 downto 0) + 1;
		end if;
		if(rst_beam_cntrB = '1')then
			beam_cntrB <= (others => '0');
		else
			beam_cntrB <= beam_cntrB + 1;
		end if;
	end if;
end process;
i_trig_bufB : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "VIRTEX6", -- Target device: "VIRTEX5", "VIRTEX6", "SPARTAN6" 
      WRITE_WIDTH => 32,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32)     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
    port map (
      DO => trig_bufB,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => beam_cntrB,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => ipb_addr(9 downto 0), -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '0',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"f",         -- Input write enable, width defined by write port depth
      WRADDR => trig_cntrB, -- Input write address, width defined by write port depth
      WRCLK => clk160from125,   -- 1-bit input write clock
      WREN => beam_trig_sync(4)      -- 1-bit input write port enable
   );
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_addr = x"0000" and ipb_write = '1' and ipb_strobe = '1')then
			reset <= ipb_wdata(0);
		else
			reset <= '0';
		end if;
		if(ipb_addr = x"0001" and ipb_write = '1' and ipb_strobe = '1')then
			PS_reg <= ipb_wdata(8 downto 0);
		end if;
		if(ipb_addr = x"0002" and ipb_write = '1' and ipb_strobe = '1')then
			mpaclk_en <= ipb_wdata(0);
			test_beam <= ipb_wdata(1);
		end if;
	end if;
end process;
process(ipb_clk, beam_trig)
begin
	if(beam_trig = '1')then
		trig_busy <= '1';
	elsif(ipb_clk'event and ipb_clk = '1')then
		if(reset = '1' or read_done = '1')then
			trig_busy <= '0';
		end if;
	end if;
end process;
process(ipb_clk, beam_start)
begin
	if(beam_start = '1')then
		IsCalib <= '0';
		read_all <= '1';
		repeat <= '1';
		read_addr <= (others => '0');
		buffer_read <= (others => '0');
		buffer_avl <= "100";
	elsif(ipb_clk'event and ipb_clk = '1')then
		if(reset = '1')then
			busy <= '0';
			acq_start <= '0';
			IsCalib <= '0';
			read_all <= '0';
			read_addr <= (others => '0');
			buffer_read <= (others => '0');
			buffer_avl <= "100";
			repeat <= '0';
			restart <= '0';
			read_start <= '0';
		elsif(test_beam = '1' and acq_done = '1')then
			read_start <= '1';
		elsif(ipb_addr(15 downto 13) = "100" and ipb_addr(12 downto 10) /= "111" and ipb_write = '0' and ipb_strobe = '1')then
			buffer_read <= ipb_addr(9 downto 8);
			if(buffer_read /= ipb_addr(9 downto 8) and repeat = '1')then
				buffer_avl <= buffer_avl + 1;
			end if;
		elsif(ipb_addr = x"0080" and ipb_write = '1' and ipb_strobe = '1')then
			busy <= '1';
			acq_start <= '1';
			read_all <= ipb_wdata(1);
			restart <= '0';
			buffer_avl <= "100";
			if(ipb_wdata(4) = '0')then
				IsCalib <= ipb_wdata(0);
				read_addr <= ipb_wdata(3 downto 2);
				repeat <= '0';
			else
				IsCalib <= '0';
				read_addr <= "00";
				buffer_read <= "00";
				repeat <= '1';
			end if;
		else
			acq_start <= '0';
			read_start <= acq_done and busy;
			if(read_done = '1')then
				buffer_avl <= buffer_avl - 1;
			end if;
			if(restart = '1' and or_reduce(buffer_avl) = '1' and test_beam = '0')then
				acq_start <= '1';
			else
				acq_start <= '0';
			end if;
			if(read_done = '1' and repeat = '1')then
				restart <= '1';
			elsif(or_reduce(buffer_avl) = '1')then
				restart <= '0';
			end if;
			if(read_done = '1')then
				if(repeat = '1')then
					read_addr <= read_addr + 1;
				else
					busy <= '0';
				end if;
			end if;
		end if;
	end if;
end process;
process(ipb_addr)
begin
	if(ipb_addr(15 downto 4) = x"000")then
		case ipb_addr(3 downto 0) is
			when x"0" => ipb_rdata <= version & zero(15 downto 0);
			when x"1" => ipb_rdata <= zero(31 downto 9) & PS_reg;
			when x"2" => ipb_rdata <= zero(31 downto 2) & test_beam & mpaclk_en;
			when x"3" => ipb_rdata <= zero(31 downto 20) & trig_cntr;
--			when x"4" => ipb_rdata <= zero(31 downto 20) & trig_cntrB;
			when x"5" => ipb_rdata <= halt_time;
			when others => ipb_rdata <= (others => '0');
		end case;
	elsif(ipb_addr = x"0080")then
		ipb_rdata <= busy & zero(30 downto 9) & (trig_busy or not rst_beam_cntrA) & buffer_avl & repeat & read_addr & read_all & IsCalib;
	elsif(ipb_addr(15 downto 10) = "101000")then
		ipb_rdata <= trig_bufA;
	elsif(ipb_addr(15 downto 10) = "101001")then
		ipb_rdata <= trig_bufB;
	else
		ipb_rdata <= strip_in_data or strip_out_data or conf_data or util_data or read_data or acq_data;
	end if;
end process;
ipb_ack <= ipb_strobe;
end Behavioral;

